![QUIQQER CSRF](bin/images/Readme.png)

QUIQQER Frontend Request Signing
========

The QUIQQER Frontend Request Signing module ensures secure and automated signing of all frontend requests through the
use of JWT (JSON Web Tokens). It provides an easy way to protect requests between the frontend and backend by adding
tokens to each request that can be verified by the server.

Package name:

    quiqqer/frontend-request-signing

Features of the FRS module:
------

- **JWT-based request signatures:**
  The module uses JWT (JSON Web Tokens) to securely sign each request and ensure authenticity.
- **Automatic integration:**
  Signatures are automatically added to XMLHttpRequest and Fetch requests without the need to manually add headers.
- **Security enhancement for API requests:** JWT token signatures ensure that only authorized requests reach the
  backend.
- **Flexible configuration**:
  Developers can customize signing behavior and control how tokens are generated and added to requests.
- **AJAX request support:**
  The module supports all types of AJAX requests (e.g. XMLHttpRequest, Fetch) and ensures that all requests are signed
  correctly.
- **Extendability through QUIQQER events:**
  Developers have the option to extend the JWT token via PHP QUIQQER events by adding additional token attributes or
  querying existing ones. by adding additional token attributes or querying existing ones.

How it works:
------

- The module automatically inserts a JWT token into the header of every XMLHttpRequest or fetch request sent , e.g.
  under X-Jwt-Token.
- The token is validated on the server side to ensure that the request originates from an authenticated source.
- The tokens are generated in a secure manner and contain relevant data such as the user ID, the request status and an
  expiration time.
- Developers only need to integrate the module once; all subsequent requests are automatically provided with a valid JWT
  token.
- The module improves security by ensuring that no unauthorized requests are sent to the backend.

Contribution
----------

- Issue Tracker: https://dev.quiqqer.com/quiqqer/frontend-request-signing/issues
- Source Code: https://dev.quiqqer.com/quiqqer/frontend-request-signing/tree/main
- Wiki: https://dev.quiqqer.com/quiqqer/frontend-request-signing/-/wikis/home

Support
-------

If you have found an error or want improvements, please send an e-mail to support@pcsg.de.

LICENCE
-------

- GPL-3.0+
- PCSG QEL-1.0
